#!/bin/sh
# \
exec wish "$0" "$@"
#
#################################################################
#               Tkmud: Xwindows mudding Application             #
#################################################################
#    Copyright (c) 1998 Dennis Reinarz dennis@rof.net
#                       Bryan L. Nylander Bryan_Nylander@ibs.uscs.com
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License   
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

wm title . "\[tkmud\]: <no server>"
wm iconname . tkmud   
wm protocol . WM_DELETE_WINDOW {exit}
wm resizable . 1 1
wm geometry . 81x27-22-14
. config -borderwidth 5
option add *background                #bdbdbd    widgetDefault
option add *highlightcolor            red        widgetDefault


###################################################################
#                      Default Configuration                      #
###################################################################

set history(0) 0    ;# array to hold the history data
set maxhistory 20   ;# max # of history
set current 0       ;# the current history entry
set startcnt 0      ;# starting count for the history

### Fonts ###

# normal text
set normal_style "-font -*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1"

# bold text
set bold_style    "-font -*-helvetica-bold-r-*-*-12-*-*-*-*-*-iso8859-1"

set userpref(menubutton_font)  "-*-helvetica-bold-r-*-*-14-*-*-*-*-*-iso8859-1"
set userpref(entryfont) "-*-helvetica-bold-r-*-*-14-*-*-*-*-*-iso8859-1"
set userpref(textfont) "-*-courier-bold-r-*-*-14-*-*-*-*-*-iso8859-1"

# COLORS

set userpref(backcolor) black         ;# Background Color
set userpref(textcolor) green         ;# Foreground Color
set userpref(echocolor) red     ;# Echo Text Color
set userpref(clientnote) purple       ;# Client Notices Color
set userpref(publicmsgcolor) red    ;# Public Messages Color
set userpref(privmsgcolor) red      ;# Private Messages Color
set userpref(actioncolor) red       ;# Actions Color
set userpref(combatcolor) red       ;# Combat Color

set userpref(framecolor) #bdbdbd
set userpref(hcolor) red

#set serv_color(1) bright
#set serv_color(2) dim
#set serv_color(4) underscore
#set serv_color(5) blink   
#set serv_color(7) reverse 
#set serv_color(8) hidden   
set serv_color(1) ""
set serv_color(2) ""
set serv_color(4) ""
set serv_color(5) ""
set serv_color(7) ""
set serv_color(8) ""
set serv_color(1) ""
set serv_color(2) ""
set serv_color(4) ""
set serv_color(5) ""
set serv_color(7) ""  
set serv_color(8) ""
set serv_color(30) "black" 
set serv_color(31) "red"   
set serv_color(32) "green"  
set serv_color(33) "yellow"
set serv_color(34) "blue"
set serv_color(35) "magenta"
set serv_color(36) "cyan"
set serv_color(37) "white"
set serv_color(40) "black"
set serv_color(41) "red"   
set serv_color(42) "green" 
set serv_color(43) "yellow" 
set serv_color(44) "blue"  
set serv_color(45) "magenta"
set serv_color(46) "cyan"   
set serv_color(47) "white"

#############################
#      DEFAULT ALIASES      #
#############################

# KEYBIND SETTINGS

set alias(keyup) n           ;# key 8
set alias(keydn) s           ;# key 2
set alias(keyright) e        ;# key 6
set alias(keyleft) w         ;# key 4
set alias(keyhome) nw        ;# key 7
set alias(keyprior) ne       ;# key 9
set alias(keyend) sw         ;# key 1
set alias(keynext) se        ;# key 3
set alias(keyins) u          ;# key 0
set alias(keydel) d          ;# key .

set userpref(cmdprefix) /       ;# what to use to prefix client command

# Serverlist - list of the servers and ports of muds
set ServerList {
    "paranoid.wolfspirit.org 3340 WolfSong"
    "mx0346.gamewood.net 4000 werewulf"
    "avatar.walrus.com 3000 Avatar"
    "midievia.com 4000 Midievia"
    "mud.inna.net 5000 Inna"
    "carrionfields.org 9999 CarrionFields"
    "ibdsun4.epfi.ch 4000 ibdsun4"
    "ux.tcs.uh.edu 3000 tcs"
    "scurvy.tender.com 6969 Scurvy"
    "storm.org 4000 Storm"
    "aargh.world-net.net 1234 World-Net"
    "storm.razernet.com.my 9000 Razernet"
    "skeeve.feld.cvut.cz 4000 Skeeve"
    "mud.imperium.net 5000 Imperium"
    "alexmud.stacken.kth.se 4000 Alexmud"
    "mud.eskimo.com 4000 Eskimo"
    "mud.compart.fi 4000 AnotherMUD"
    "sapphire.geo.wvu.edu 4000 Apocalypse IV"
    "beta.arcadia.net 4000 Arcadia"
    "mud.imperium.net 9999 Arrant Destiny"
    "mud.artic.org 2700 Artic"
}

###############################################################
#                DO NOT EDIT BELOW THIS LINE                  #
###############################################################

set mudserver(hostname)       0       ;# Holds the name of the current server
set mudserver(socket)         0       ;# This holds the socket name of the mud port
set mudserver(state)          0       ;# This will determine if then input is
                                      ;# read line at a time or charictor at a time
# This is the line which is build provided by the server. This line will have a delay of $mudserver(delay)
# once that time occurs, then the line will display in the window regardless if it is done or not. It
# is to assume that it will not take $mudserver(delay) long to build a single line. After that, it is
# assumed that the line is a prompt, which will need to be filtered.

set mudserver(inbound_line)   ""
set mudserver(hostname)       0       ;# This holds the name of the current connected server
set mudserver(portnum)        0       ;# This holds the number of the port of the currently connected server


####################################
# make sure rc files are avaliable #
####################################

switch $tcl_platform(platform) {
  unix {
    if [file exists $env(HOME)/.tkmudrc] {
      set fi [open $env(HOME)/.tkmudrc r]
      while {![eof $fi]} {
        set line [gets $fi]
        if {[lindex $line 0] == "TKMUD_LIB:"} {
          set TKMUD_LIB [lindex $line 1]
          break
        }
      }
      catch {close $fi}
      if ![info exists TKMUD_LIB] {
        tk_dialog .notkmud_lib "tkmud" \ 
"Your $env(HOME)/.tkmudrc file does not have the TKMUD_LIB: line in it.
please locate your TKMUD_LIB directory and put into your .tkmudrc
    
TKMUD_LIB: <directory of TKMUD_LIB Directory>" error 0 "DOH! I hate it when that happens"
        exit   
      }  
    } else {
      if [file exists /usr/etc/system.tkmudrc] {
        set fi [open /usr/etc/system.tkmudrc r]
        while {![eof $fi]} {
          set line [gets $fi]
          if {[lindex $line 0] == "TKMUD_LIB:"} {
            set TKMUD_LIB [lindex $line 1]
            break
          }    
        }
        catch {close $fi}
        if ![info exists TKMUD_LIB] {
          tk_dialog .notkmud_lib "tkmud" \
"Well I have bad news for you.
          
Unable to locate TKMUD_LIB: line in
/usr/etc/system.tkmudrc. contact your
Systems Administrator" error 0 "DOH! I hate it when that happens"
          exit 
        }
      } else {
        tk_dialog .sol "tkmud" \
"You do not have a local .tkmudrc file
OR a /usr/etc/system.tkmudrc file.
          
Is tkmud installed yet???

Please run the intkmud.tcl script to install." error "" 0 "yeah, Install, good.."
       exit    
      }  
    }
  }
  macintosh {
puts stdout "not yet"
  }       
  windows {
#luny
    if ![file exists c:/windows/tkmud.ini] {
      tk_dialog .oops "tkmud" \
"You don't have a TKMUD.ini file in C:/WINDOWS.
I guess we can't go there Today." error 0 "And me without a spoon"
      exit
    } else { 
      set fi [open C:/WINDOWS/tkmud.ini r]
      while {![eof $fi]} {
        set line [gets $fi]
        if {[lindex $line 0] == "TKMUD_LIB:"} {
          set TKMUD_LIB [lindex $line 1]
          break
        }
      }
      catch {close $fi}
      if ![info exists TKMUD_LIB] {
        tk_dialog .notkmud_lib "tkmud" \  
"Well I have bad news for you.
        
Unable to locate TKMUD_LIB: line in
c:/windows/tkmud.ini" error 0 "DOH! I hate it when that happens"
        exit   
      }  
    }  
  }
}

# set text into bottom status line
# writen by T-Wolf aka Mark Kusler
# writeStatus large "text"  sets the large status bar only
# writeStatus small "text"  sets the small status bar only
# writeStatus "text one" "text two" sets Large then Small status text
proc writeStatus { lab foo } {
   if { ($lab == "large") || ($lab == "small") } {
     switch $lab {
      "large" { .statusBar.lab configure -text $foo }
      "small" { .statusBar.foo configure -text $foo }
     }
   } else {   
      .statusBar.lab configure -text $lab
      .statusBar.foo configure -text $foo
   }
}

############
#   HELP   #
############

set aboutmsg {
tkmud v0.1
Copyright 1998
Dennis Reinarz
Bryan L. Nylander

Please send bug reports (details!), enhancements, patches,
comments, etc. to: dennis@rof.net
    
Enjoy using tkmud!
}

# general information about the client
proc about {} {
    global aboutmsg
    tk_dialog .about "tkmud" $aboutmsg info 0 OK
}

# clear the window and start a clean slate
proc clearwindow {} {

  .t.show configure -state normal
  .t.show delete 0.0 end
  .t.show configure -state disabled
}

# page up through the screen
proc TextPageUp {} {
  set top [lindex [.t.show yview] 0]
  set bottom [lindex [.t.show yview] 1]
  set diff [expr $bottom - $top]
  if {$top > 0} {
    .t.show yview moveto [expr $top - $diff]
  }
}

# page down through the screen    
proc TextPageDown {} {
  set mark [lindex [.t.show yview] 1]
  if {$mark < 1} {
    .t.show yview moveto $mark
  }
}   


############
#   MAIN   #
############

proc main {} {
     global userpref TKMUD_LIB serv_color tcl_platform alias env
     # frame for the menu
     frame .mb -relief raised -borderwidth 2 -background white
     # Read Global Aliases
     if [file exists $env(HOME)/.tkmud/globals/userprefs] {
        GetAliases global
     }
     # file menu
     set m .mb.file
     menubutton $m -menu $m.menu -text "File" -underline 0 -bd 0 -background white -font $userpref(menubutton_font)
     menu $m.menu
     $m.menu  add command -label "Connect" -command { ServerWindow }
     $m.menu add command -label "Disconnect" -command { Disconnect }
     $m.menu add separator
     $m.menu add command -label "Clear Window" -command { clearwindow }
     $m.menu add command -label "Aliases" -command { AliasGUI }
     $m.menu add command -label "Colors" -command { DoColors }
     $m.menu add separator
     $m.menu add command -label "Quit" -command {exit 0}
     pack $m -side left -padx 5
     
     # help menu
     set m .mb.help
     menubutton $m -menu $m.menu -text "Help" -underline 0 -bd 0 -background white -font $userpref(menubutton_font)
     menu $m.menu
     $m.menu add command -label "About" -command { about }
     pack $m -side left -padx 5
     pack .mb -fill x -side top

     # frame for the toolbar
     image create photo logo -file "$TKMUD_LIB/tkmud01.gif"
     image create photo logo2 -file "$TKMUD_LIB/tkmud02.gif"
     image create photo logo3 -file "$TKMUD_LIB/tkmud03.gif"
     image create photo logo4 -file "$TKMUD_LIB/tkmud04.gif"

     frame .toolbar -relief raised -borderwidth 2
     button .toolbar.connect -image logo -command { ServerWindow } -bd 0 -highlightthickness 0
     button .toolbar.disconnect -image logo2 -command { Disconnect } -bd 0 -highlightthickness 0
     button .toolbar.setup -image logo3 -command { ;#connect } -bd 0 -highlightthickness 0
     button .toolbar.options -image logo4 -command { ;#connect } -bd 0 -highlightthickness 0
     pack .toolbar.connect .toolbar.disconnect .toolbar.setup .toolbar.options -side left
     pack .toolbar -fill both -side top

     # frame the side
     frame .side -bd 2 -width 70 -relief raised
     pack .side -side right -fill both

     # frame for the text box
     frame .t -relief sunken -background white 
     scrollbar .t.scroll -width 10 -orient vertical \
          -command [list .t.show yview ]
     text .t.show -relief sunken  -wrap word -setgrid 1 -state disabled \
           -yscrollcommand [list .t.scroll set] -bg $userpref(backcolor) \
           -fg $userpref(textcolor) -font $userpref(textfont)
     pack .t.scroll -side right -fill y
     pack .t -side top -fill both -expand true
     pack .t.show -fill both -expand true
     .t.show tag configure serv_color_30 -foreground $serv_color(30)
     .t.show tag configure serv_color_31 -foreground $serv_color(31)
     .t.show tag configure serv_color_32 -foreground $serv_color(32) 
     .t.show tag configure serv_color_33 -foreground $serv_color(33)
     .t.show tag configure serv_color_34 -foreground $serv_color(34)
     .t.show tag configure serv_color_35 -foreground $serv_color(35)
     .t.show tag configure serv_color_36 -foreground $serv_color(36)
     .t.show tag configure serv_color_37 -foreground $serv_color(37)
     .t.show tag configure serv_color_40 -background $serv_color(40)
     .t.show tag configure serv_color_41 -background $serv_color(41)
     .t.show tag configure serv_color_42 -background $serv_color(42)
     .t.show tag configure serv_color_43 -background $serv_color(43) 
     .t.show tag configure serv_color_44 -background $serv_color(44)
     .t.show tag configure serv_color_45 -background $serv_color(45)
     .t.show tag configure serv_color_46 -background $serv_color(46)
     .t.show tag configure serv_color_47 -background $serv_color(47)

     # bind all <Select> { select } 
     bind .t.show <ButtonPress-3> { tk_popup .popup %X %Y ; break }
     bind all <Shift-Prior> { .t.show yview 0 }
     bind all <Shift-Next> { .t.show yview end }
     bind all <Prior> { TextPageUp }
     bind all <Next> { TextPageDown }

     # frame for the entry box
     entry .cmdline -bg white -font $userpref(entryfont)
     bind .cmdline <Return> { entry2mud [.cmdline get] ; .cmdline delete 0 end }
     bind .cmdline <Up> { HistoryUp }   
     bind .cmdline <Down> { HistoryDn }
     # bind .cmdline <Button-2> { paste .cmdline }
     bind .cmdline <Control-u> { .cmdline delete 0 end }
     pack .cmdline -side top -fill x
     focus .cmdline

     #  bind the 10 key keypad to the directions
     switch $tcl_platform(platform) {
        unix { bind .cmdline <KP_Up> { send2mud $alias(keyup) }
               bind .cmdline <KP_Down> { send2mud $alias(keydn) }
               bind .cmdline <KP_Left> { send2mud $alias(keyleft) }
               bind .cmdline <KP_Right> { send2mud $alias(keyright) }
               bind .cmdline <KP_End> { send2mud $alias(keyend) }
               bind .cmdline <KP_Next> { send2mud $alias(keynext) }
               bind .cmdline <KP_Home> { send2mud $alias(keyhome) }
               bind .cmdline <KP_Prior> { send2mud $alias(keyprior) }
               bind .cmdline <KP_Insert> { send2mud $alias(keyins) }
               bind .cmdline <KP_Delete> { send2mud $alias(keydel) }
             }
        windows {
               bind .cmdline <Up> { send2mud $alias(keyup) }
               bind .cmdline <Down> { send2mud $alias(keydn) }
               bind .cmdline <Left> { send2mud $alias(keyleft) }
               bind .cmdline <Right> { send2mud $alias(keyright) }
               bind .cmdline <Next> { send2mud $alias(keyend) }
               bind .cmdline <End> { send2mud $alias(keynext) }
               bind .cmdline <Home> { send2mud $alias(keyhome) }
               bind .cmdline <Prior> { send2mud $alias(keyprior) }
               bind .cmdline <Insert> { send2mud $alias(keyins) }
               bind .cmdline <Delete> { send2mud $alias(keydel) } 
                }
        macintosh {
               
                  }
     }


     # frame for the status bar
     frame .statusBar
     label .statusBar.lab -text "   " -relief sunken -bd 1 -anchor w
     label .statusBar.clock -text " " -relief sunken -bd 1 -anchor w -width 11
     label .statusBar.meter -width 15 -relief sunken -bd 1 -anchor w
     canvas .statusBar.meter.canvas -height 16 -width 100
     .statusBar.meter.canvas create rectangle 0 0 0 16 -fill blue -tags line
     pack .statusBar.lab -side left -padx 2 -expand yes -fill both
     pack .statusBar.clock -side left -padx 2
     pack .statusBar.meter -side left -padx 2
     pack .statusBar.meter.canvas -side left -fill both -expand true
     pack .statusBar -side bottom -fill x -pady 2
     ShowClock
}

proc ShowClock {} {
     .statusBar.clock configure -text  "[clock format [clock seconds] -format %r]"
     update
     after 1000 ShowClock
}

proc UpdateMeter { current lines } {
   .statusBar.meter.canvas coords line  0 0 [expr ($current*100)/$lines] 16
   update
}

proc showmeter {} {
    set count 0
    set lines [lindex [exec wc tkmud.hold] 0]
    for { set i 0 } {$i < $lines} {incr i} {
        incr count
        UpdateMeter $count $lines
    }
    .statusBar.meter.canvas coords line 0 0 0 16
} 

# showStatus --
#
#       Show the name of the demo program in the status bar. This procedure
#       is called when the user moves the cursor over a demo description.
#
proc showStatus {text} {
        .statusBar.lab config -text "Run the \"$demo\" sample program"
        .t config -cursor $newcursor
}

proc ServerWindow {} {
     global ServerList
     
     toplevel .servers
     wm title .servers  " tkmud: servers "
     bind .servers <Escape> "destroy .servers" 
     raise .servers

     # create the listbox
     MultiListbox .servers.list 3 {Comment 12} {Hostname 40} {Port 7}
     MultiListbox_Delete .servers.list 3 0 end

     set w .servers.listbox
     foreach server $ServerList {
         set comment [lrange $server 2 end]
         set host [lindex $server 0]
         set port [lindex $server 1]
         if {$comment == ""} {
            set comment "<none>"
         }
        MultiListbox_Insert .servers.list 3 end \
        $comment $host $port
     }
     pack .servers.list -side top -expand true -fill both -ipadx 0 -padx 0
    
     MultiListbox_Bind .servers.list 3 <ButtonPress-1> "+ServerSelected"
     MultiListbox_Bind .servers.list 3 <ButtonRelease-1> "+ServerSelected"
     MultiListbox_Bind .servers.list 3 <B1-Motion> "+ServerSelected"

     # create a frame for the entry to show the selected server
     entry .servers.entry
     pack .servers.entry -fill x -padx 2 -pady 2 -side top
     focus .servers.entry

     # create a frame for the buttons
     set w .servers.buttons
     frame $w
     pack $w -side bottom -fill x -pady 2
     button $w.cancel -text "Cancel" -command {destroy .servers}
     button $w.connect -text "Connect" -command { ServerConfirmed }
     button $w.new -text "New"
     pack $w.cancel -side right -padx 2 -pady 2
     pack $w.connect -side right -padx 2 -pady 2
     pack $w.new -side right -padx 2 -pady 2
     bind .servers <Return> "ServerConfirmed"
}


##################
#  MultiListbox  #
##################

proc MultiListbox {path lists args} {
  frame $path -bd 2 -relief sunken

  frame $path.frameb ; pack $path.frameb -side right -fill y
  scrollbar $path.frameb.bar -width 10 -orient vertical \
    -command "MultiListbox_Yview $path $lists"
  if {"$args" != ""} {
    label $path.frameb.label -text " "
    pack $path.frameb.label
  }
  pack $path.frameb.bar -expand true -fill y

  for {set i 0} {$i < $lists} {incr i} {
    frame $path.frame$i ; pack $path.frame$i -side left -expand true -fill both
    if {"$args" != ""} {
      if {[llength "$args"] > $i} {
        label $path.frame$i.label -text "[lindex "[lindex "$args" $i]" 0]"
      } else {
        label $path.frame$i.label -text " "
      }
      pack $path.frame$i.label
    }

    listbox $path.frame$i.list -exportselection false -relief raised \
      -yscrollcommand "MultiListbox_Set $path $i $lists {}"

    if {"[lindex "[lindex "$args" $i]" 1]" != ""} {
      $path.frame$i.list configure -width "[lindex "[lindex "$args" $i]" 1]"
    }

    pack $path.frame$i.list -padx 0 -ipadx 0 -side left -expand true -fill both

    foreach x "1 2 3" {
      bind $path.frame$i.list <B$x-Motion> \
        "MultiListbox_Set $path $i $lists %y"
      bind $path.frame$i.list <ButtonRelease-$x> \
        "MultiListbox_Set $path $i $lists %y"
      bind $path.frame$i.list <ButtonPress-$x> \
        "MultiListbox_Set $path $i $lists %y"
    }
  }
}

proc MultiListbox_Set {path num lists y args} {
  if {"$y" != ""} {
    set selected "[$path.frame$num.list nearest $y]"
  } else {
    set selected "[$path.frame$num.list curselection]"
  }
  set yview "[lindex "[$path.frame$num.list yview]" 0]"

  for {set i 0} {$i < $lists} {incr i} {
    eval $path.frame$i.list yview moveto $yview
    eval $path.frame$i.list selection clear 0 end
    foreach x "$selected" {
      eval $path.frame$i.list selection set $x
    }
  }
  if {"$args" != ""} { 
    eval $path.frameb.bar set $args
  }
}

proc MultiListbox_Yview {path lists args} {
  for {set i 0} {$i < $lists} {incr i} {
    eval $path.frame$i.list yview $args
  }
}

proc MultiListbox_Delete {path lists args} {
  if {[winfo exists $path]} { 
    for {set i 0} {$i < $lists} {incr i} {
      eval $path.frame$i.list delete $args
    }
  }
}

proc MultiListbox_Selected {path} {
  if {[winfo exists $path]} {
    return "[$path.frame0.list curselection]"
  }
  return ""
}
   
proc MultiListbox_Insert {path lists place args} {
  if {[winfo exists $path]} {
    set end "[lindex "[$path.frame0.list yview]" 1]"
    for {set i 0} {$i < $lists} {incr i} {
      if {[llength "$args"] > $i} {
        $path.frame$i.list insert $place "[lindex "$args" $i]"
      } else {
        $path.frame$i.list insert $place " "
      }
      if {$end == 1} {
        $path.frame$i.list yview end
      }
    }
  }
}
     
proc MultiListbox_Get {path list place} {
  if {[winfo exists $path]} {
    return "[$path.frame$list.list get $place]"
  }
  return ""
}
   
proc MultiListbox_Bind {path lists sequence command} {
  for {set i 0} {$i < $lists} {incr i} {
    bind $path.frame$i.list $sequence "$command"
  }
}

#######################
#   SERVER MODULES    #
#######################

proc ServerSelected { } {  
  .servers.entry delete 0 end
  set selected "[MultiListbox_Selected .servers.list]"
  if {"$selected" != ""} {
    .servers.entry insert end "[MultiListbox_Get .servers.list 1 $selected] [MultiListbox_Get .servers.list 2 $selected]"
  }
}
proc ServerConfirmed { } {
   set toconnect "[.servers.entry get]"
   if {"$toconnect" != ""} {
      connect2server [lindex $toconnect 0] [lindex $toconnect 1]
      destroy .servers
   } else {
      bell
   }
}

##########################
#    CONNECTION MODULE   #
##########################

# disconnect from the current server
proc Disconnect {} {
   global mudserver
   send2text "-- Disconnected from server ---"
   close $mudserver(socket)
   set mudserver(socket) 0
   wm title . "\[tkmud\]: <no server>"
   return 0
}

# This is where the connections will be opened
# and maintianed
proc connect2server { server port } {
     global env mudserver
     if {$mudserver(socket) != 0} {
       Disconnect
     }
     send2text "--- connecting to $server $port ---"
     wm title . "\[tkmud\]: $server $port"

     # check to make sure that the connection was made
     # sucessfully if not let the user know
     if [catch { socket $server $port } mudserver(socket)] {
        send2text "--- unable to connect to $server - $port ---"
        set mudserver(socket) 0
        return 0
     } else {
       fconfigure $mudserver(socket) -blocking 0
       fileevent $mudserver(socket) readable "SocketInput"
       set mudserver(hostname) $server
       set mudserver(portnum) $port
       if [file exists $env(HOME)/.tkmud/globals/userprefs] {
          GetAliases global
       }
       GetAliases server
     }
}

# new inproved way of grabbing data from a pipeline and filtering it out
# to send to the GUI interface.  This is much more effecient and much quicker

proc SocketInput { } {
   global mudserver userpref
   set inbound_line ""
   set char ""
   # check to make sure the connection still exists
   # and notify the user when the connection drops
   # retrieve the data from the socket connection
   set inbound_line [read $mudserver(socket) ]
   if {$inbound_line == "" } {
      Disconnect
      send2text "-- remote server has closed the connection ---"
      return 0
   }

   # filter out the escape codes one by checking each
   # character and building the line of data
   # to be sent the the window.
   for {set i 0} {$i <= [string length "$inbound_line"]} {incr i} {
       set char "[string index "$inbound_line" $i]"
       switch -- "$char" {
                 "\x02" { # bold }
                 "\x0f" { # bold }
                 "\x11" {}
                 "\x16" {}
                 "\x1f" { # underline }
                 "\x03" { # space??? }
                 "\x01" { # space??? }
                 "\x1b[0m" {}
                 "\x1b[35m" { # bold }
                 "\a" { bell }
                 "\x07" { bell }
                 "" {}
                 "" {}
                 "" {}
                 "" {}
                 " " { append newline "$char" }
                 default { append newline "$char" }
       }
   }
   # write the filtered line to the window
    set end "[lindex "[.t.show yview]" 1]"
   .t.show config -state normal
   .t.show insert end $newline { textcolor }
   .t.show tag configure servercolor -foreground $userpref(textcolor)
    if {$end == 1} {
        .t.show yview end
    }
   .t.show config -state disabled
}

# Filter Through all the lines provided by mudserver(socket)
proc InAliasCheck {} {
  global mudserver userpref serv_color
      
# Set server charictor control for turning on or off using
# userpref(show_colors)
  set count_1b [llength [split $mudserver(inbound_line) \x1b]]
  set count_01 [llength [split $mudserver(inbound_line) \x01]]
  set count_02 [llength [split $mudserver(inbound_line) \x02]]
  set count_03 [llength [split $mudserver(inbound_line) \x03]]
  if {($count_1b != 1 || $count_01 != 1 || $count_02 != 1 || $count_03 != 1)} {
    if {$userpref(show_colors) == "off"} {
      set in_control 1
      set out_line \"
      for {set i 0} {$i <= [string length "$mudserver(inbound_line)"]} {incr i} {
        set char "[string index "$mudserver(inbound_line)" $i]"
        switch -- "$char" {
          "\x1b" { set in_control 0}
          "\x01" { set in_control 0}
          "\x02" { set char "" }
          "\x03" { set char "" }
            m    { set in_control 1 ; set char ""}
        }
        if {$in_control == 1} {
          append out_line $char
        }
      }
      set mudserver(inbound_line) $out_line\"
    } else {
# SHOW COLORS THE SERVER SENDS  
# NOT WORKING MUST BE FIXIED using ser_color_# calls from tags
#  put in .t.show
#      set in_control 0
#      set color_set 0
#      set sample [strings match \x1b[.*m $mudserver(inbound_line)]
#puts $sample
#      if [string match "x1b\[.*m" $mudserver(inbound_line)] {
#        puts GOT_IT
#      }
    }
  }
# End section for
# userpref(show_colors)
  if {[string length $mudserver(inbound_line)] == 0} { return 0 }
  .t.show config -state normal
  .t.show insert end $mudserver(inbound_line) { servercolor }
  .t.show tag configure servercolor -foreground $userpref(servercolor)
  .t.show yview end 
  set mudserver(inbound_line) ""
  .t.show config -state disabled
}  

# this send all the output from the commandline to the server and to the client
proc send2mud {line} {
   global mudserver userpref
   .t.show config -state normal
   if {$mudserver(socket) == 0} {
      send2text "--- You are not connected to a Mud Server ---"
      return 0
   }
   puts $mudserver(socket) $line
   flush $mudserver(socket)
   .t.show insert end "$line\n" { echocolor }
   .t.show tag configure echocolor -foreground $userpref(echocolor)
   .t.show yview end
   .t.show config -state disabled
}


# this is for client notices which uses a diffent color
# so the user can easily see them
proc send2text {line} {
   global mudserver userpref
   .t.show config -state normal
   .t.show insert end "$line\n" { notecolor }
   .t.show tag configure notecolor -foreground $userpref(clientnote)
   .t.show yview end
   .t.show config -state disabled
}

# This is called from the command line when the user
# hits enter.  It searches to see if a client command 
# was ented and passed it on to the client otherwise sends 
# the input to the server

proc entry2mud  {line} {
  global mudserver userpref current startcnt
  # synchornize the count for the commandline history
  set startcnt 1
  # add input from the command line to the history
  AddHistory $line
  # is it a command?
  if {[string index $line 0] == "/"} { 
      set cmdline [string trimleft $line "$userpref(cmdprefix)"]
      set command [lindex $cmdline 0]
      set parms [lrange $cmdline 1 end]
      DoCommand $command $parms
      return 0
   }
  # check for a open socket
  if {$mudserver(socket) != 0} {
    send2mud $line
  } else {
    send2text "--- You are not connected to a Mud Server ---"
  }
} 


#########################################
#          COMMAND AND ALIASES          #
#########################################

# load aliases
proc GetAliases { where } {
   global userpref serv_color mudserver alias env
   switch $where {
      "server" {
         set aliasfile "$env(HOME)/.tkmud/$mudserver(hostname)_$mudserver(portnum)/userprefs"
         if { (![file exists $aliasfile]) } {
            send2text "--I'm sorry the file $aliasfile doesn't exist... checking for older server-based rc file--"
            if ![file isdirectory $env(HOME)/.tkmud/$mudserver(hostname)_$mudserver(portnum)] {

            }
         } else {
            ReadAliases $aliasfile
         }
      }
      "global" {
         set aliasfile "$env(HOME)/.tkmud/globals/userprefs"
         ReadAliases $aliasfile
      }
   }
}

proc ReadAliases { aliasfile } {
   global userpref serv_color mudserver alias env
#   send2text "Reading $aliasfile"
   set fi [open $aliasfile r]
   while {![eof $fi]} {
      set line [gets $fi]
      switch [lindex $line 0] {
         "alias" {
            set alias([lindex $line 1]) "[lrange $line 2 end]"
         }
         "pref" {
            set userpref([lindex $line 1]) "[lrange $line 2 end]"
         }
         "servcode" {
            set serv_color([lindex $line 1]) "[lrange $line 2 end]"
         }
      }
   }
}

proc savestuff { where } {
   global serv_color userpref mudserver alias env
   if ![file isdirectory $env(HOME)/.tkmud] {
      file mkdir $env(HOME)/.tkmud
   }
   switch $where {
      "server" {
         if ![file isdirectory $env(HOME)/.tkmud/$mudserver(hostname)_$mudserver(portnum)] {
            if [file exists $env(HOME)/.tkmud/$mudserver(hostname)_$mudserver(portnum)] {
               file rename $env(HOME)/.tkmud/$mudserver(hostname)_$mudserver(portnum) $env(HOME)/.tkmud/$mudserver(hostname)_$mudserver(portnum).userprefs
               file mkdir $env(HOME)/.tkmud/$mudserver(hostname)_$mudserver(portnum)
               file rename $env(HOME)/.tkmud/$mudserver(hostname)_$mudserver(portnum).userprefs $env(HOME)/.tkmud/$mudserver(hostname)_$mudserver(portnum)/userprefs
            } else {
               file mkdir $env(HOME)/.tkmud/$mudserver(hostname)_$mudserver(portnum)
            }
         }
         set aliasfile "$env(HOME)/.tkmud/$mudserver(hostname)_$mudserver(portnum)/userprefs"
         set fo [open $aliasfile w+]
         foreach { aliasdef } [array names alias]  {
            puts $fo "alias $aliasdef $alias($aliasdef)"
         }
         foreach { preference } [array names userpref] {
            puts $fo "pref $preference $userpref($preference)"
         }
         foreach { servercode } [array names servercode] {
            puts $fo "servcode $servercode $serv_color($servercode)"
         }
         close $fo
         send2text "Server Preferences Saved"
      }
      "global" {
         if ![file isdirectory $env(HOME)/.tkmud/globals] {
            if [file exists $env(HOME)/.tkmud/globals] {
               file rename $env(HOME)/.tkmud/globals $env(HOME)/.tkmud/globals.saved
            }
            file mkdir $env(HOME)/.tkmud/globals
         }
         set aliasfile "$env(HOME)/.tkmud/globals/userprefs"
         set fo [open $aliasfile w+]
         foreach { aliasdef } [array names alias]  {
            puts $fo "alias $aliasdef $alias($aliasdef)"
         }
         foreach { preference } [array names userpref] {
            puts $fo "pref $preference $userpref($preference)"
         }
         foreach { servercode } [array names servercode] {
            puts $fo "servcode $servercode $serv_color($servercode)"
         }
         close $fo
         send2text "GLOBAL Preferences Saved"
      }
   }
}

# process the input data from the command line
# as a command later this will call a alias file 
# depending on which server you are connected to
proc DoCommand { command args } {
   global alias userpref serv_color
   if [info exists alias($command)] {
      if {[lindex $alias($command) 0] == "PROC"} {
         catch [eval [join [lrange $alias($command) 1 end]]]
      } else {
         send2mud "$alias($command) [join $args]"
      }
   } else {
      switch $command {
         "alias" {
            set alias([lindex [join $args] 0]) [lrange [join $args] 1 end]
            send2text "/[lindex [join $args] 0] created as \"[lrange [join $args] 1 end]\""
         }
         "aliaslist" {
            foreach aliasname [array names alias] {
               send2text "$aliasname $alias($aliasname)"
            }
         }
         "clear" { clearwindow ; return }
         "disconnect" { Disconnect }
         "gload" {
            send2text "Resetting All Settings to GLOBAL defaults"
            GetAliases global
         }
         "gsave" { savestuff global }
         "load"  {
            send2text "Reloading Previous Settings"
            GetAliases global
            GetAliases server
         }
         "rehash" { ReHashColor }
         "save" { savestuff server }
         "set" {
            set userpref([lindex [join $args] 0]) [lrange [join $args] 1 end]
            send2text "[lindex [join $args] 0] saved as \"[lrange [join $args] 1 end]\""
         }
         "unalias" {
            if [info exists alias([lindex [join $args] 0])] {
               unset alias([lindex [join $args] 0])
               send2text "/[lindex [join $args] 0] removed as an alias"
            } else {
               send2text "HEY NOW... /[lindex [join $args] 0] isn't an alias!!"
            }
         }
      }
   }
}


proc beep { } {
    global mudserver
    if {$mudserver(socket) == 0} {
       return
    }
    bell
    puts $mudserver(socket) \a
    flush $mudserver(socket)

}

#################################
#      COMMAND LINE HISTORY     #
#################################

# add the entry from the command line
# the the histoy so we don't have to type so much
proc AddHistory {line} {
  global maxhistory history current
  if { $line == ""} { return 0 }
  if { $history(0) == 0 } {
     set history(0) $line
     return 0
  }
  set newhistory(0) $line
  for { set i 0; set j 1 } {$i < [array size history]} { incr i; incr j } {
      if {[expr $i + 1] <= $maxhistory} {
         set newhistory($j) $history($i)
      }
  }
  set tmp [array get newhistory]
  array set history $tmp
  return 0
}

# page up through the command line history
proc HistoryUp {} {
  global current history startcnt
  if { $history(0) == 0 } { return 0 }
  .cmdline delete 0 end
  if { $startcnt } {
     set current 0 
     .cmdline insert 0 $history($current)
     set startcnt 0
     return 0
  } 
  if { $current == [expr [array size history] - 1]} {
     set current 0
  } else {
     incr current
  }
  .cmdline insert 0 $history($current)
}

# page down through the command line history
proc HistoryDn {} {
  global current history startcnt
  if { $history(0) == 0 } { return 0 }  
  .cmdline delete 0 end
  if { $startcnt } {
     set current [expr [array size history] - 1]
     .cmdline insert 0 $history($current)
     set startcnt 0
     return 0
  }
  if { $current == 0 } {
     set current [expr [array size history] - 1]
  } else {
     incr current -1
  }
  .cmdline insert 0 $history($current)
}

######################################
# START FILE TRANSFER SECTION        #
######################################

set client_sockets() ""
set file_transfer_port 8010
  
proc establish_file_transfer_port {} {
  global file_transfer_port
  set actual_port $file_transfer_port 
  set start_server 1
  while {$start_server == 1} {
    set start_server [catch {socket -server check_local_con $actual_port} nn]
    if  {$start_server == 1} {
      incr actual_port
    } else {
      set start_server 0
      if {$file_transfer_port != $actual_port} {
        tk_messageBox -message "I was Unable to use port $file_transfer_port \
           for file transfer as desired. It is currently being used.  \
           Your File Transfer Port is now $actual_port" -type ok
        set file_transfer_port $actual_port
      }
    }
  }
}

# Clean up File Transfer sockets and look for errors
proc CleanupFTP {in out file bytes {error {}}} {
    global total
    set total $bytes
    close $in
    close $out
    if {[string length $error] != 0} {
      tk_dialog .errorTime "tkmud" "you received an error receiving \[$file\]: $error: " error 0 "darn"
    } else {
      tk_dialog .fileDone "tkmud" "Succesful transfer of \[$file\]
Size: $bytes" "" 0 "woohoo"
    }
}

# checks local connection
proc check_local_con {sock ip c_port} {
  set filename [gets $sock]
  set remote_hostname [lindex [fconfigure $sock -sockname] 1]
  set ok_to_get [tk_dialog .get_file "tkmud" \
    "\[$remote_hostname\] is offering to send to you a file named \[$filename\] \
    Do you want to accept this file?" "" 0 "Sure, lets have it" "I don't think so"]
  if {$ok_to_get == 1} {
    puts $sock "REJECTED"
    catch {close $sock}
    return 0
  } else {
    set types {
        {"Text files"           {.txt .doc}     }
        {"Text files"           {}              TEXT}
        {"Tcl Scripts"          {.tcl}          TEXT}
        {"C Source Files"       {.c .h}         }
        {"All Source Files"     {.tcl .c .h}    }
        {"Image Files"          {.gif}          }
        {"Image Files"          {.jpeg .jpg}    }
        {"Image Files"          ""              {GIFF JPEG}}
        {"Wav Files"            {.wav}          }
        {"All files"            *}
    }
    set new_filename [tk_getSaveFile -filetypes $types -parent . \
            -initialfile $filename]
    set new_file [open $new_filename w]
    fconfigure $sock -translation binary
    fconfigure $new_file -translation binary
    fcopy $sock $new_file -command [list CleanupFTP $sock $new_file $new_filename ]
  }
}

proc read_ftp_socket {sock new_file new_filename} {
  while {![eof $sock]} {
    puts $new_file [read $sock 1]
  }
  if [eof $sock] {
    catch {close $sock}
    catch {close $new_file}
    fileevent $sock readable
    tk_dialog .file_receive "tkmud" "finished Receiving file \[$new_filename\]" "" 0 "thanks"
  }     
}
#luny
proc SendFile { } {
  set BACKGROUND white
  toplevel .send2host
  .send2host configure -background $BACKGROUND
  label .send2host.label1 -wraplength 5i -bg $BACKGROUND -justify left -text "hostname: "
  label .send2host.label2 -wraplength 5i -bg $BACKGROUND -justify left -text "port: "
  entry .send2host.entry1 -relief sunken -bg #fefec4
  entry .send2host.entry2 -relief sunken -bg #fefec4
  button .send2host.quit -text "quit" -bg $BACKGROUND -command {destroy .send2host}
  button .send2host.ok -text "ok" -bg $BACKGROUND \
   -command {
     set HOSTNAME [ .send2host.entry1 get]
     set PORT     [ .send2host.entry2 get]
     if {($HOSTNAME != "") } {
       if {$PORT == ""} {
         set PORT 8010
       }
       destroy .send2host
       set types {
        {"Text files"           {.txt .doc}     }
        {"Text files"           {}              TEXT}
        {"Tcl Scripts"          {.tcl}          TEXT}
        {"C Source Files"       {.c .h}         }
        {"All Source Files"     {.tcl .c .h}    }
        {"Image Files"          {.gif}          }
        {"Image Files"          {.jpeg .jpg}    }
        {"Image Files"          ""              {GIFF JPEG}}
        {"Wav Files"            {.wav}          }
        {"All files"            *}
       }
       set send_file [tk_getOpenFile -filetypes $types]
       set fi [open $send_file r]
       set sock [socket $HOSTNAME $PORT]
       puts $sock [lindex [split $send_file /] end]
       flush $sock
       fconfigure $sock -translation binary
       fconfigure $fi -translation binary
       fcopy $fi $sock -command [list CleanupFTP $fi $sock $send_file ]
     } else {
       tk_dialog .oops "tkmud" "Oops forgot to fill something out?" error 0 "DOh,,"
     }
   }
  pack .send2host.label1 .send2host.entry1 -side top
  pack .send2host.label2 .send2host.entry2 -side top
  pack .send2host.ok .send2host.quit
}

establish_file_transfer_port
       
######################################
# END FILE TRANSFER SECTION          #
######################################


#############################
#       SELECTIONS          #
#############################

proc paste { t } {
   if [catch {selection get} sel] {
      if [catch {selection get -selection CLIPBOARD} sel] {
         # no selection or clipboard data
         return
      }
   }
   $t insert insert $sel
}

#proc bgerror { message } { 
#     puts stderr $message
#}


#######################
#        POPUPS       #
#######################


  set m [menu .popup -tearoff 1]
  $m add command -label Command -command { send2text "popup command" }
  $m add check -label boolean -variable foo \
         -command { send2text "foo = $foo" }
  $m add separator
  $m add cascade -label cascade -menu $m.sub1
  set m2 [menu $m.sub1 -tearoff 0]
  $m2 add radio -label one -variable choice
  $m2 add radio -label two -variable choice
  $m2 add radio -label three -variable choice 


#######################
#     COLOR MODULE    #
#######################

proc UpDateColors {} {
   global userpref
   set l .colors.preview.list
   $l tag configure tagcolor1 -foreground $userpref(backcolor)
   $l tag configure tagcolor2 -foreground $userpref(textcolor)
   $l tag configure tagcolor3 -foreground $userpref(echocolor)
   $l tag configure tagcolor4 -foreground $userpref(clientnote)
   $l tag configure tagcolor5 -foreground $userpref(publicmsgcolor)
   $l tag configure tagcolor6 -foreground $userpref(privmsgcolor)
   $l tag configure tagcolor7 -foreground $userpref(actioncolor)
   $l tag configure tagcolor8 -foreground $userpref(combatcolor)
   update idletasks
}

# add in ReHashColor when ok button is selected
# Set geomentry
proc DoColors { } {
   global userpref
   catch [destroy .colors]
   set w [toplevel .colors]
   wm title $w "tkmud: Color selection"
   wm geometry $w 24x11
   if {[winfo depth $w] > 1} {
      set bold "-background #43ce50 -relief raised -borderwidth 1"
      set normal "-background {} -relief flat"
   } else {
      set bold "-foreground white -background black"
      set normal "-foreground {} -background {}"
   }
   frame $w.preview
   # textbox that lists the preview text
   set l [text $w.preview.list -yscrollcommand [list $w.preview.sy set] \
   -width 20 -height 5 -setgrid true]
   scrollbar $w.preview.sy -orient vertical -command [list $w.preview.list yview]
   pack $w.preview -fill both -expand true
   pack $w.preview.sy -side right -fill y
   pack $w.preview.list -side left -fill both -expand true

   # colorize the preview display
   UpDateColors
   $l insert end "BackGround\n" { tagcolor1 }
   $l insert end "Default Output\n" { tagcolor2 }
   $l insert end "Client Messages\n" { tagcolor3 }
   $l insert end "Own Messages\n" { tagcolor4 }
   $l insert end "Public Messages\n" { tagcolor5 }
   $l insert end "Private Messages\n" { tagcolor6 }
   $l insert end "Actions\n" { tagcolor7 }
   $l insert end "Combat Text\n" { tagcolor8 }

   frame $w.buttons
   pack $w.buttons -side bottom
   button $w.buttons.ok -text "Ok" -activebackground white -command {
      destroy .colors
      ReHashColor
   }
   button $w.buttons.cancel -text "Cancel" -activebackground white -command { destroy .colors }
   pack $w.buttons.ok $w.buttons.cancel -side left -fill x -padx 5 -pady 5 -expand true

   # create the tag bindings
   foreach tag {tagcolor1 tagcolor2 tagcolor3 tagcolor4 tagcolor5 tagcolor6 tagcolor7 tagcolor8 } {
      $l tag bind $tag <Any-Enter> "$l tag configure $tag $bold"
      $l tag bind $tag <Any-Leave> "$l tag configure $tag $normal"
   }

   $l tag bind tagcolor1 <1> { set userpref(backcolor) \
      [tk_chooseColor -initialcolor $userpref(backcolor)]
      .t.show configure -bg $userpref(backcolor)
   }
#luny
   $l tag bind tagcolor2 <1> { set userpref(textcolor) \
       [tk_chooseColor -initialcolor $userpref(textcolor)]
       UpDateColors
       ReHashColor
   }
   $l tag bind tagcolor3 <1> { set userpref(echocolor) \
       [tk_chooseColor -initialcolor $userpref(echocolor)]
       UpDateColors
       ReHashColor
   }
   $l tag bind tagcolor4 <1> { set userpref(clientnote) \
       [tk_chooseColor -initialcolor $userpref(clientnote)]
       UpDateColors
       ReHashColor
   }
   $l tag bind tagcolor5 <1> { set userpref(publicmsgcolor) \
       [tk_chooseColor -initialcolor $userpref(publicmsgcolor)]
       UpDateColors
       ReHashColor
   }
   $l tag bind tagcolor6 <1> { set userpref(privmsgcolor) \
       [tk_chooseColor -initialcolor $userpref(privmsgcolor)]
       UpDateColors
       ReHashColor
   }
   $l tag bind tagcolor7 <1> { set userpref(actioncolor) \
       [tk_chooseColor -initialcolor $userpref(actioncolor)]
       UpDateColors
       ReHashColor
   }
   $l tag bind tagcolor8 <1> { set userpref(combatcolor) \
       [tk_chooseColor -initialcolor $userpref(combatcolor)]
       UpDateColors
       ReHashColor
   }
   $l mark set insert 0.0
   $l configure -state disabled
}

proc ReHashColor {} {
   send2text "Rehashing"
   global alias userpref serv_color env
   .t.show config -state normal
   .mb.help.menu configure -font $userpref(menubutton_font)
   .t.show configure -bg $userpref(backcolor) -fg $userpref(textcolor) -font $userpref(textfont)
   .cmdline configure -font $userpref(entryfont)
   .t.show tag configure tagcolor4 -foreground $userpref(clientnote)
   .t.show config -state disabled
}

# open the main window
if [file exists ~/my.tkmud.source] {
  source ~/my.tkmud.source
  puts "loading ~/my.tkmud.source"
}

main
